<?php
require_once("../../../wp-config.php");

$asdb_dir = preg_replace("/^.*[\/\\\]/", "", dirname(__FILE__));
if (!defined("ASDB_DIR")) { define("ASDB_DIR", "/wp-content/plugins/" . $asdb_dir);}


// Получаем данные из формы
$action = isset($_POST["submitted"]) ? $_POST["submitted"] : "";
if ($action == "send") {
	// Если получен сигнал send
	$name   = isset($_POST["name"]) ? $_POST["name"] : "";
	$email = isset($_POST["email"]) ? $_POST["email"] : "";
	$subject = isset($_POST["subject"]) ? $_POST["subject"] : "";
	$message = isset($_POST["message"]) ? $_POST["message"] : "";
	$token = isset($_POST["token"]) ? $_POST["token"] : "";
	$author_id = isset($_POST["author_id"]) ? $_POST["author_id"] : "";
        $mailTo = get_the_author_meta('user_email', $author_id);
	// Сравниваем токены, если совпадают, формируем сообщение если нет - выход
	if ($token == ASDBAuthorInfo::token()) {
		sendEmail($name, $email, $subject, $message, $mailTo);
		_e("1");
	}
	else {
		_e("0");
	}
}

// функция отправки почты
function sendEmail($name, $email, $subject, $message, $mailTo) {
	$to = $mailTo;
	// фильтруем Имя отправителя и Тему сообщения
	$name = filter($name);
	$subject = empty($subject) ? get_option("asdb_subject") : filter($subject);
	// Удаляем экранирование символов
	$message = stripslashes($message);
	// Фильтруем и проверяем Email
	$email = filter($email);
	if (!validateEmail($email)) {
		$subject .= " - invalid email";
		$message .= "\n\nBad email: $email";
		$email = $to;
	}
	// формируем сообщение
	$body = "From: $name\n";
	$body .= "Message: $message\n";
	$body = wordwrap($body); // По умолчанию 75 символов
	// Формируем заголовок письма
	$headers = "From: $email\n";
	$headers .= "X-Mailer: PHP/ASDBAuthorInfo\n";
	// Конвертируем строку в кодированное слово для поля шапки UTF-8
	if (function_exists('mb_encode_mimeheader')) {
		$subject = mb_encode_mimeheader($subject, "UTF-8", "B", "\n");
	}
	else {
	}
	$headers .= "MIME-Version: 1.0\n";
	$headers .= "Content-type: text/plain; charset=utf-8\n";
	$headers .= "Content-Transfer-Encoding: quoted-printable\n";
	// Отправляем сформированное письмо


  if(mail($to, $subject, $body, $headers)){
	echo 'Сообщение отправлено';
   }else{
        echo "Ошибка отправки сообщения";
   }
    exit;
}

// Удаляем небезопасные значения
function filter($value) {
	$pattern = array("/\n/", "/\r/", "/content-type:/i", "/to:/i", "/from:/i");
	$value = preg_replace($pattern, "", $value);
	return $value;
}
// Валидация email адреса
function validateEmail($email) {
	$at = strrpos($email, "@");
	// Проверяем, чтобы символ @ не был первым или последним
	if ($at && ($at < 1 || ($at + 1) == strlen($email)))
		return false;
	// Make sure there aren't multiple periods together
	if (preg_match("/(\.{2,})/", $email))
		return false;
	// Разделяем локальный и внешний домены
	$local = substr($email, 0, $at);
	$domain = substr($email, $at + 1);
	// проверяем количество символов в домене
	$locLen = strlen($local);
	$domLen = strlen($domain);
	if ($locLen < 1 || $locLen > 64 || $domLen < 4 || $domLen > 255)
		return false;
	// Фильтруем точку в начале и конце
	if (preg_match("/(^\.|\.$)/", $local) || preg_match("/(^\.|\.$)/", $domain))
		return false;
	// Адрес в ковычках? Разрешаем
	if (!preg_match('/^"(.+)"$/', $local)) {
		if (!preg_match('/^[-a-zA-Z0-9!#$%*\/?|^{}`~&\'+=_\.]*$/', $local))
			return false;
	}
	// Проверяем допустимые символы и наличие хотя бы одной точки разделителя
	if (!preg_match('/^[-a-zA-Z0-9\.]*$/', $domain) || !strpos($domain, "."))
		return false;	
	return true;
}
exit;
?>